diff -ruN ../nakedmudv3.7/src/storage.c src/storage.c
--- ../nakedmudv3.7/src/storage.c	2008-05-31 00:17:59.000000000 -0400
+++ src/storage.c	2009-03-02 01:00:41.000000000 -0500
@@ -11,6 +11,7 @@
 //
 //******************************************************************************
 
+#include <time.h>
 #include "mud.h"
 #include "utils.h"    // trim
 #include "storage.h"
@@ -57,9 +58,9 @@
 bool list_is_empty(STORAGE_SET_LIST *list);
 bool set_is_empty (STORAGE_SET *set);
 
-void write_storage_set(STORAGE_SET *set, FILE *fl, int indent);
-void write_storage_list(STORAGE_SET_LIST *list, FILE *fl, int indent);
-void write_storage_data(STORAGE_DATA *data, FILE *fl, int key_width,int indent);
+void write_storage_set(STORAGE_SET *set, FILEBUF *fb, int indent);
+void write_storage_list(STORAGE_SET_LIST *list, FILEBUF *fb, int indent);
+void write_storage_data(STORAGE_DATA *data, FILEBUF *fb, int key_width,int indent);
 
 
 void delete_storage_set(STORAGE_SET *set) {
@@ -125,26 +126,26 @@
 }
 
 STORAGE_DATA    *new_data_int(int val, const char *key) {
-  char str_val[20]; sprintf(str_val, "%d", val);
+  char str_val[20]; snprintf(str_val, 20, "%d", val);
   return new_data_string(str_val, key);
 }
 
 STORAGE_DATA    *new_data_long(long val, const char *key) {
-  char str_val[20]; sprintf(str_val, "%ld", val);
+  char str_val[20]; snprintf(str_val, 20, "%ld", val);
   return new_data_string(str_val, key);
 }
 
 STORAGE_DATA *new_data_double(double val, const char *key) {
-  char str_val[20]; sprintf(str_val, "%lf", val);
+  char str_val[20]; snprintf(str_val, 20, "%lf", val);
   return new_data_string(str_val, key);
 }
 
 
-void print_indent(FILE *fl, int indent) {
+void print_indent(FILEBUF *fb, int indent) {
   if(indent > 0) {
     char fmt[20];
     sprintf(fmt, "%%%ds", indent);
-    fprintf(fl, fmt, " ");
+    fbprintf(fb, fmt, " ");
   }
 }
 
@@ -152,17 +153,17 @@
 //
 // Print a key and the key delimeter to file
 //
-void print_key(FILE *fl, const char *key, int key_width, int indent) {
+void print_key(FILEBUF *fb, const char *key, int key_width, int indent) {
   char fmt[30];
   sprintf(fmt, "%%-%ds:", key_width);
-  print_indent(fl, indent);
-  fprintf(fl, fmt, key);
+  print_indent(fb, indent);
+  fbprintf(fb, fmt, key);
 }
 
 //
 // write a string containing newlines to a file
 //
-void write_string_data(const char *string, FILE *fl, int indent) {
+void write_string_data(const char *string, FILEBUF *fb, int indent) {
   static char buf[SMALL_BUFFER];
   int i, str_i, do_indent;
   *buf = '\0';
@@ -172,11 +173,11 @@
     buf[i++] = string[str_i];
     if(i == SMALL_BUFFER-1 || string[str_i] == '\n') {
       if(do_indent == TRUE) {
-	print_indent(fl, indent);
+	print_indent(fb, indent);
 	do_indent = FALSE;
       }
       buf[i] = '\0';
-      fprintf(fl, "%s", buf);
+      fbprintf(fb, "%s", buf);
       i = 0;
       if(string[str_i] == '\n')
 	do_indent = TRUE;
@@ -229,34 +230,34 @@
 }
 
 
-void write_storage_data(STORAGE_DATA *data, FILE *fl, int key_width,int indent){
+void write_storage_data(STORAGE_DATA *data, FILEBUF *fb, int key_width,int indent){
   // first, we see if we have a string value. If we do, print it
   if(*data->str_val) {
-    print_key(fl, data->key, key_width, indent);
+    print_key(fb, data->key, key_width, indent);
     // if we have a newline in our string, we have to write
     // it in a special way so as to preserve the lines
     if(count_letters(data->str_val, '\n', strlen(data->str_val)) > 0) {
       // first, print the string marker and skip down to a newline
-      fprintf(fl, "%c\n", STRING_MARKER);
+      fbprintf(fb, "%c\n", STRING_MARKER);
       // now, write the string
-      write_string_data(data->str_val, fl, indent+2);
+      write_string_data(data->str_val, fb, indent+2);
     }
     else
-      fprintf(fl, "%c%s\n", TYPELESS_MARKER, data->str_val);
+      fbprintf(fb, "%c%s\n", TYPELESS_MARKER, data->str_val);
   }
 
   // If that fails, check if we have a set value. If we do, print it
   else if(!set_is_empty(data->set_val)) {
-    print_key(fl, data->key, key_width, indent);
-    fprintf(fl, "%c\n", SET_MARKER);
-    write_storage_set(data->set_val, fl, indent+2);
+    print_key(fb, data->key, key_width, indent);
+    fbprintf(fb, "%c\n", SET_MARKER);
+    write_storage_set(data->set_val, fb, indent+2);
   }
 
   // otherwise, check if we have a list value. If we do, print it
   else if(!list_is_empty(data->list_val)) {
-    print_key(fl, data->key, key_width, indent);
-    fprintf(fl, "%c\n", LIST_MARKER);
-    write_storage_list(data->list_val, fl, indent+2);
+    print_key(fb, data->key, key_width, indent);
+    fbprintf(fb, "%c\n", LIST_MARKER);
+    write_storage_list(data->list_val, fb, indent+2);
   }
 }
 
@@ -275,7 +276,7 @@
 }
 
 
-void write_storage_set(STORAGE_SET *set, FILE *fl, int indent) {
+void write_storage_set(STORAGE_SET *set, FILEBUF *fb, int indent) {
   // collect all of the items in our hashtable
   LIST           *elems = newList();
   HASH_ITERATOR *hash_i = newHashIterator(set->entries);
@@ -291,21 +292,21 @@
 
   // now, for each one, print it
   while( (data = listPop(elems)) != NULL)
-    write_storage_data(data, fl, set->longest_key, indent);
+    write_storage_data(data, fb, set->longest_key, indent);
   deleteList(elems);
 
   // print our indent and the end-of-set marker
-  print_indent(fl, indent);
-  fprintf(fl, "%c\n", SET_MARKER);
+  print_indent(fb, indent);
+  fbprintf(fb, "%c\n", SET_MARKER);
 }
 
 
-void write_storage_list(STORAGE_SET_LIST *list, FILE *fl, int indent) {
+void write_storage_list(STORAGE_SET_LIST *list, FILEBUF *fb, int indent) {
   LIST_ITERATOR *list_i = newListIterator(list->list);
   STORAGE_SET      *set = NULL;
 
   ITERATE_LIST(set, list_i)
-    write_storage_set(set, fl, indent);
+    write_storage_set(set, fb, indent);
   deleteListIterator(list_i);
 }
 
@@ -318,25 +319,25 @@
 //*****************************************************************************
 
 /* local functions */
-STORAGE_SET      *parse_storage_set(FILE *fl, int indent);
-STORAGE_SET_LIST *parse_storage_list(FILE *fl, int indent);
+STORAGE_SET      *parse_storage_set(FILEBUF *fb, int indent);
+STORAGE_SET_LIST *parse_storage_list(FILEBUF *fb, int indent);
 
 
 //
 // skip ahead in our indent. If we can skip that far ahead,
 // return TRUE. otherwise, return FALSE.
 //
-bool skip_indent(FILE *fl, int indent) {
+bool skip_indent(FILEBUF *fb, int indent) {
   int i;
   char c;
   for(i = 0; i < indent; i++) {
-    c = fgetc(fl);
+    c = fbgetc(fb);
     if(c != ' ')
       break;
   }
 
   if(i != indent) {
-    fseek(fl, -(i+1), SEEK_CUR);
+    fbseek(fb, -(i+1), SEEK_CUR);
     return FALSE;
   }
   else
@@ -348,15 +349,15 @@
 // Check to see if we're at the end of a storage entry. If we are,
 // return true. otherwise, return false.
 //
-bool storage_end(FILE *fl) {
-  char c = fgetc(fl);
+bool storage_end(FILEBUF *fb) {
+  char c = fbgetc(fb);
   if(c == SET_MARKER) {
     // also skip the newline that comes after us
-    fgetc(fl);
+    fbgetc(fb);
     return TRUE;
   }
   else {
-    fseek(fl, -1, SEEK_CUR);
+    fbseek(fb, -1, SEEK_CUR);
     return FALSE;
   }
 }
@@ -366,20 +367,20 @@
 // return the type of the data we're dealing with. It is assumed
 // this will be called IMMEDIATELY after parse_key is called
 //
-char parse_type(FILE *fl) {
-  return getc(fl);
+char parse_type(FILEBUF *fb) {
+  return fbgetc(fb);
 }
 
 
 //
 // Parse the name of the key that is immediately in front of us
 //
-char *parse_key(FILE *fl) {
+char *parse_key(FILEBUF *fb) {
   static char buf[SMALL_BUFFER];
   char c;
   int  i = 0;
   // parse up to the colon, which is the marker for the end of the key
-  while((c = fgetc(fl)) != EOF) {
+  while((c = fbgetc(fb)) != EOF) {
     if(c == ':') {
       buf[i] = '\0';
       break;
@@ -395,7 +396,7 @@
 //
 // Read until we hit a newline. Return a copy of what we find
 //
-char *parse_line(FILE *fl) {
+char *parse_line(FILEBUF *fb) {
   static BUFFER *buf = NULL;
   static char   sbuf[SMALL_BUFFER];
   int              i = 0;
@@ -405,12 +406,12 @@
   *sbuf = 0;
 
   // fill up our small buffer to max, then copy it over
-  for(i = 0; (sbuf[i] = getc(fl)) != EOF && sbuf[i] != '\n';) {
+  for(i = 0; (sbuf[i] = fbgetc(fb)) != EOF && sbuf[i] != '\n';) {
     if(i < SMALL_BUFFER-2)
       i++;
     else {
       sbuf[++i] = '\0';
-      bprintf(buf, "%s", sbuf);
+      bufferCat(buf, sbuf);
       i = 0;
       sbuf[i] = '\0';
     }
@@ -419,7 +420,7 @@
   // we found the newline
   if(sbuf[i] == '\n')
     sbuf[i] = '\0';
-  bprintf(buf, "%s", sbuf);
+  bufferCat(buf, sbuf);
   return strdup(bufferString(buf));
 }
 
@@ -427,7 +428,7 @@
 //
 // read in a string that may possibly have multiple newlines in it
 //
-char *parse_string(FILE *fl, int indent) {
+char *parse_string(FILEBUF *fb, int indent) {
   static BUFFER *buf = NULL;
   char          *ptr = NULL;
   if(buf == NULL)
@@ -437,9 +438,10 @@
   // as long as we can skip up our indent, we can read in data and
   // all is good. Once we can no longer skip up our indent, then
   // we have come to the end of our string
-  while(skip_indent(fl, indent)) {
-    ptr = parse_line(fl);
-    bprintf(buf, "%s\n", ptr);
+  while(skip_indent(fb, indent)) {
+    ptr = parse_line(fb);
+    bufferCat(buf, ptr);
+    bufferCat(buf, "\n");
     free(ptr);
   }
 
@@ -450,12 +452,12 @@
 //
 // Read in a list of storage sets. Return what we find.
 //
-STORAGE_SET_LIST *parse_storage_list(FILE *fl, int indent) {
+STORAGE_SET_LIST *parse_storage_list(FILEBUF *fb, int indent) {
   STORAGE_SET_LIST *list = new_storage_list();
   STORAGE_SET       *set = NULL;
 
   // read in each set in our list
-  while( (set = parse_storage_set(fl, indent)) != NULL)
+  while( (set = parse_storage_set(fb, indent)) != NULL)
     storage_list_put(list, set);
   return list;
 }
@@ -464,42 +466,42 @@
 //
 // Parse one storage set and return it
 //
-STORAGE_SET *parse_storage_set(FILE *fl, int indent) {
+STORAGE_SET *parse_storage_set(FILEBUF *fb, int indent) {
   STORAGE_SET *set = new_storage_set();
   int        loops = 0;
 
-  while(skip_indent(fl, indent)) {
+  while(skip_indent(fb, indent)) {
     loops++;
-    if(storage_end(fl))
+    if(storage_end(fb))
       break;
 
-    char *key = parse_key(fl);
-    char type = parse_type(fl);
+    char *key = parse_key(fb);
+    char type = parse_type(fb);
 
     switch(type) {
     case TYPELESS_MARKER: {
-      char *line = parse_line(fl);
+      char *line = parse_line(fb);
       store_string(set, key, line);
       free(line);
       break;
     }
 
     case STRING_MARKER: {
-      fgetc(fl); // kill the newline
-      char *string = parse_string(fl, indent+2);
+      fbgetc(fb); // kill the newline
+      char *string = parse_string(fb, indent+2);
       store_string(set, key, string);
       free(string);
       break;
     }
 
     case SET_MARKER:
-      fgetc(fl); // kill the newline
-      store_set(set, key, parse_storage_set(fl, indent+2));
+      fbgetc(fb); // kill the newline
+      store_set(set, key, parse_storage_set(fb, indent+2));
       break;
 
     case LIST_MARKER:
-      fgetc(fl); // kill the newline
-      store_list(set, key, parse_storage_list(fl, indent+2));
+      fbgetc(fb); // kill the newline
+      store_list(set, key, parse_storage_list(fb, indent+2));
       break;
     }
     free(key);
@@ -522,12 +524,12 @@
 //
 //*****************************************************************************
 void storage_write(STORAGE_SET *set, const char *fname) {
-  FILE *fl = NULL;
+  FILEBUF *fb = NULL;
   // we wanted to open a file, but we couldn't ... abort
-  if((fl = fopen(fname, "w+")) == NULL)
+  if((fb = fbopen(fname, "w+")) == NULL)
     return;
-  write_storage_set(set, fl, 0);
-  fclose(fl);
+  write_storage_set(set, fb, 0);
+  fbclose(fb);
 }
 
 
@@ -546,12 +548,25 @@
 
 
 STORAGE_SET *storage_read(const char *fname) {
-  FILE *fl = NULL;
+  FILEBUF *fb = NULL;
   // we wanted to open a file, but we couldn't ... return an empty set
-  if((fl = fopen(fname, "r")) == NULL)
+  if((fb = fbopen(fname, "r")) == NULL)
     return NULL;//    return new_storage_set();
-  STORAGE_SET *set = parse_storage_set(fl, 0);
-  fclose(fl);
+
+  // track how long it takes us to parse a storage set
+  // struct timeval start_time;
+  // gettimeofday(&start_time, NULL);
+
+  STORAGE_SET *set = parse_storage_set(fb, 0);
+
+  // finish tracking
+  // struct timeval end_time;
+  // gettimeofday(&end_time, NULL);
+  // int usecs = (int)(end_time.tv_usec - start_time.tv_usec);
+  // int secs  = (int)(end_time.tv_sec  - start_time.tv_sec);
+  // log_string("storage read time %d %s", (int)(secs*1000000 + usecs), fname);
+
+  fbclose(fb);
   return set;
 }
 
@@ -615,7 +630,7 @@
   storage_put(set, new_data_long(val, key));
 }
 
-STORAGE_SET    *read_set(STORAGE_SET *set, const char *key) {
+STORAGE_SET *read_set(STORAGE_SET *set, const char *key) {
   STORAGE_DATA *data = hashGet(set->entries, key);
   if(data) 
     return data->set_val;
@@ -625,7 +640,7 @@
   }
 }
 
-STORAGE_SET_LIST    *read_list(STORAGE_SET *set, const char *key) {
+STORAGE_SET_LIST *read_list(STORAGE_SET *set, const char *key) {
   STORAGE_DATA *data = hashGet(set->entries, key);
   if(data) 
     return data->list_val;
diff -ruN ../nakedmudv3.7/src/strings.c src/strings.c
--- ../nakedmudv3.7/src/strings.c	2008-05-31 00:17:59.000000000 -0400
+++ src/strings.c	2009-03-02 01:00:41.000000000 -0500
@@ -95,11 +95,19 @@
   while (isspace(*fStr))
     fStr++; 
 
+  char arg_end = ' ';
+
+  // are we using quotation marks or commas to specify multiple words?
+  if(*fStr == '"' || *fStr == '\'') {
+    arg_end = *fStr;
+    fStr++;
+  }
+
   /* copy the beginning of the string */
   while (*fStr != '\0')
   {
     /* have we reached the end of the first word ? */
-    if (isspace(*fStr))
+    if (*fStr == arg_end)
     {
       fStr++;
       break;
diff -ruN ../nakedmudv3.7/src/time/time.c src/time/time.c
--- ../nakedmudv3.7/src/time/time.c	2008-05-31 00:17:59.000000000 -0400
+++ src/time/time.c	2009-03-02 01:00:41.000000000 -0500
@@ -96,6 +96,17 @@
   return Py_BuildValue("i", get_hour());
 }
 
+PyObject *PyMud_GetTime(PyObject *self) {
+  if(is_morning())
+    return Py_BuildValue("s", "morning");
+  else if(is_afternoon())
+    return Py_BuildValue("s", "afternoon");
+  else if(is_evening())
+    return Py_BuildValue("s", "evening");
+  else
+    return Py_BuildValue("s", "night");
+}
+
 PyObject *PyMud_IsMorning(PyObject *self) {
   return Py_BuildValue("i", is_morning());
 }
@@ -181,6 +192,7 @@
 
   // add our mud methods
   PyMud_addMethod("get_hour",     PyMud_GetHour,     METH_NOARGS, NULL);
+  PyMud_addMethod("get_time",     PyMud_GetTime,     METH_NOARGS, NULL);
   PyMud_addMethod("is_morning",   PyMud_IsMorning,   METH_NOARGS, NULL);
   PyMud_addMethod("is_afternoon", PyMud_IsAfternoon, METH_NOARGS, NULL);
   PyMud_addMethod("is_evening",   PyMud_IsEvening,   METH_NOARGS, NULL);
diff -ruN ../nakedmudv3.7/src/utils.h src/utils.h
--- ../nakedmudv3.7/src/utils.h	2008-12-06 00:20:20.000000000 -0500
+++ src/utils.h	2009-03-02 01:00:41.000000000 -0500
@@ -62,6 +62,16 @@
 #define HESHE(ch)             (charGetSex(ch) == SEX_MALE ? "he" : \
 			       (charGetSex(ch) == SEX_FEMALE ? "she" : "it"))
 
+#define YESNO(val)            (val == FALSE ? "no" : "yes")
+
+#define TOGGLE(val)           (val == FALSE ? TRUE : FALSE)
+
+//
+// register a check that's performed when can_see_char/obj/exit is called.
+// Returns True if the target is visible, and False if it is not.
+void  register_char_see   ( bool (* check)(CHAR_DATA *ch, CHAR_DATA *target));
+void  register_obj_see    ( bool (* check)(CHAR_DATA *ch, OBJ_DATA *target));
+void  register_exit_see   ( bool (* check)(CHAR_DATA *ch, EXIT_DATA *target));
 bool  can_see_char        ( CHAR_DATA *ch, CHAR_DATA *target);
 bool  can_see_obj         ( CHAR_DATA *ch, OBJ_DATA  *target);
 bool  can_see_exit        ( CHAR_DATA *ch, EXIT_DATA *exit);
@@ -74,6 +84,7 @@
 // and returns SOMEONE/SOMETHING otherwise.
 const char *see_char_as (CHAR_DATA *ch, CHAR_DATA *target);
 const char *see_obj_as  (CHAR_DATA *ch, OBJ_DATA  *target);
+const char *see_exit_as (CHAR_DATA *ch, EXIT_DATA *target);
 
 void     show_prompt(SOCKET_DATA *socket);
 const char *custom_prompt (CHAR_DATA *ch);
@@ -85,10 +96,10 @@
 //*****************************************************************************
 #define BITS_PER_BITVECTOR                   32
 
-#define IS_SET(flag,bit)        ((flag) & (bit))
-#define SET_BIT(var,bit)        ((var) |= (bit))
-#define REMOVE_BIT(var,bit)    ((var) &= ~(bit))
-#define TOGGLE_BIT(var,bit)     ((var) ^= (bit))
+#define IS_SET(flag,bit)       (((flag) &  (bit)) != 0)
+#define SET_BIT(var,bit)        ((var) |=  (bit))
+#define REMOVE_BIT(var,bit)     ((var) &= ~(bit))
+#define TOGGLE_BIT(var,bit)     ((var) ^=  (bit))
 
 bitvector_t parse_bits(const char *string);
 const char *write_bits(bitvector_t bits);
@@ -124,7 +135,23 @@
 int next_space_in         (const char *string);
 int next_letter_in        (const char *string, char marker);
 int is_paragraph_marker   (const char *string, int index);
-int string_hash           (const char *key);
+
+//
+// four unique hash functions for 8-bit hashing. They can be concatinated
+// to do higher-order hashing as would be typically desired
+unsigned long    pearson_hash8(const char *string, int *table);
+unsigned long  pearson_hash8_1(const char *string);
+unsigned long  pearson_hash8_2(const char *string);
+unsigned long  pearson_hash8_3(const char *string);
+unsigned long  pearson_hash8_4(const char *string);
+unsigned long pearson_hash16_1(const char *string);
+unsigned long pearson_hash16_2(const char *string);
+unsigned long   pearson_hash32(const char *string);
+
+//
+// aliases pearson_hash32
+unsigned long string_hash(const char *key);
+
 bool endswith             (const char *string, const char *end);
 bool startswith           (const char *string, const char *start);
 const char *strcpyto      (char *to, const char *from, char end);
@@ -155,6 +182,13 @@
 void do_mass_transfer(ROOM_DATA *from, ROOM_DATA *to, bool chars, bool mobs, 
 		      bool objs);
 
+// handles relative exits. If an exit destination does not have a locale, 
+// append the one for its room.
+const char *exitGetToFull(EXIT_DATA *exit);
+
+// find the root room of an object; traverse its containers and carriers
+ROOM_DATA *objGetRootRoom(OBJ_DATA *obj);
+
 
 
 //*****************************************************************************
@@ -203,6 +237,16 @@
 const char *get_shortkey(const char *key, const char *to);
 
 //
+// return whether the key is malformed in some way. Keys can only contain
+// letters, numbers, underscores, and a single @ sign
+bool key_malformed(const char *key);
+
+//
+// returns whether a key locale is malformed. This is true if it contains any
+// non-alphanumeric characters
+bool locale_malformed(const char *locale);
+
+//
 // Returns whether or not the command matches the pattern. Patterns are just
 // like commands, except they can be terminated with *'s to signify that
 // "anything can follow at this point". Example matches might include:
diff -ruN ../nakedmudv3.7/src/world.c src/world.c
--- ../nakedmudv3.7/src/world.c	2008-12-06 00:20:20.000000000 -0500
+++ src/world.c	2009-03-02 01:03:04.000000000 -0500
@@ -18,6 +18,15 @@
 
 
 //*****************************************************************************
+// optional modules
+//*****************************************************************************
+#ifdef MODULE_PERSISTENT
+#include "persistent/persistent.h"
+#endif
+
+
+
+//*****************************************************************************
 // defines, structures, local functions
 //*****************************************************************************
 
@@ -138,7 +147,6 @@
   return TRUE;
 }
 
-
 void worldInit(WORLD_DATA *world) {
   char buf[MAX_BUFFER];
   sprintf(buf, "%s/world", world->path);
@@ -199,7 +207,7 @@
 
 const char *worldGetZonePath(WORLD_DATA *world, const char *key) {
   static char buf[SMALL_BUFFER];
-  sprintf(buf, "%s/%s", world->path, key);
+  sprintf(buf, "%s/zones/%s", world->path, key);
   return buf;
 }
 
@@ -220,15 +228,21 @@
   ROOM_DATA *room = NULL;
   // see if we have it in the room hashtable
   if( (room = hashGet(world->rooms, key)) == NULL) {
-    char name[SMALL_BUFFER], locale[SMALL_BUFFER];
-    if(parse_worldkey(key, name, locale)) {
-      ZONE_DATA *zone = hashGet(world->zones, locale);
-      if(zone != NULL) {
-	PROTO_DATA *rproto = zoneGetType(zone, "rproto", name);
-	if(rproto != NULL && (room = protoRoomRun(rproto)) != NULL)
-	  worldPutRoom(world, protoGetKey(rproto), room);
+#ifdef MODULE_PERSISTENT
+    if( (room = worldGetPersistentRoom(world, key)) == NULL) {
+#endif
+      char name[SMALL_BUFFER], locale[SMALL_BUFFER];
+      if(parse_worldkey(key, name, locale)) {
+	ZONE_DATA *zone = hashGet(world->zones, locale);
+	if(zone != NULL) {
+	  PROTO_DATA *rproto = zoneGetType(zone, "rproto", name);
+	  if(rproto != NULL && (room = protoRoomRun(rproto)) != NULL)
+	    worldPutRoom(world, protoGetKey(rproto), room);
+	}
       }
+#ifdef MODULE_PERSISTENT
     }
+#endif
   }
   return room;
 }
diff -ruN ../nakedmudv3.7/src/zone.c src/zone.c
--- ../nakedmudv3.7/src/zone.c	2008-12-06 00:20:20.000000000 -0500
+++ src/zone.c	2009-03-02 01:00:41.000000000 -0500
@@ -101,7 +101,7 @@
   HASHTABLE       *type_table; // a table of our types and their functions
   int             pulse_timer; // the timer duration
   int                   pulse; // how far down have we gone?
-  HASHTABLE   *auxiliary_data; // additional data installed on us
+  AUX_TABLE   *auxiliary_data; // additional data installed on us
 };
 
 
@@ -167,7 +167,7 @@
   zone->pulse--;
   if(zone->pulse == 0) {
     zone->pulse = zone->pulse_timer;
-    hookRun("reset", hookBuildInfo("str", zoneGetKey(zone)));
+    hookRun("reset_zone", hookBuildInfo("str", zoneGetKey(zone)));
   }
 }
 
@@ -243,7 +243,7 @@
 // get and set functions for zones
 //*****************************************************************************
 void *zoneGetAuxiliaryData(const ZONE_DATA *zone, char *name) {
-  return hashGet(zone->auxiliary_data, name);
+  return auxiliaryGet(zone->auxiliary_data, name);
 }
 
 int zoneGetPulseTimer(ZONE_DATA *zone) { 
@@ -326,7 +326,7 @@
   struct dirent *entry = NULL;
   if(dir != NULL) {
     for(entry = readdir(dir); entry; entry = readdir(dir)) {
-      if(strcmp(entry->d_name, ".") != 0 && strcmp(entry->d_name, "..") != 0)
+      if(!startswith(entry->d_name, "."))
 	listPut(key_list, strdup(entry->d_name));
     }
     closedir(dir);
diff -ruN ../nakedmudv3.7/lib/pymodules/__restricted_builtin_funcs__.py lib/pymodules/__restricted_builtin_funcs__.py
--- ../nakedmudv3.7/lib/pymodules/__restricted_builtin_funcs__.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/__restricted_builtin_funcs__.py	2009-03-02 01:43:35.000000000 -0500
@@ -12,7 +12,7 @@
     '''Restricted __import__ only allows importing of specific modules'''
 
     ok_modules = ("mud", "obj", "char", "room", "exit", "account", "mudsock",
-                  "event", "action", "random", "traceback",
+                  "event", "action", "random", "traceback", "utils",
                   "__restricted_builtin__")
     if name not in ok_modules:
         raise ImportError, "Untrusted module, %s" % name
